Subject: bug#49592: 28.0.50; lisp-current-defun-name and non-standard defuns

From: Lars Ingebrigtsen <[email-masked]>
Date: Thu, 04 Aug 2022 18:31:22 +0200

Michael Heerdegen <[email-masked]> writes:

> consider a top-level expression like this (you might want to insert this
> snipped into *scratch* for testing):
>
> (progn
>   ;; comment
>   ;; about that
>   (define-key ...)
>   )
>
> With `which-function-mode' enabled, more or less the complete expression
> is shown in the mode-line (with newlines escaped) when moving into the
> expression.
>
> The reason: `lisp-current-defun-name' doesn't check for whether the
> second subexpression of a top-level expression is still on the same line
> - it just returns a string including everything (i.e. all comments) in
> between.

This function is documented as:

(defun lisp-current-defun-name ()
  "Return the name of the defun at point, or nil."

There is no defun at point in this situation, so perhaps it would make
sense to return nil here?  But this is also used by add-log, so perhaps
which-func should just use something completely different and more
strict.  I.e., skip back to the top-level form, and then use the edebug
spec to pick out the name?